<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../favicon.png">
  <title>Distributions | Chi documentation</title>
  <link rel="stylesheet" href="../assets/asciidoctor-escet-chi.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../assets/styles/asciidoctor-highlightjs-escet.min.css"><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../assets/asciidoctor-escet-chi.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="..">Chi website</a></p>
    <div id="toctitle">
     Chi documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation.html">Home</a></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/index.html">Chi Tutorial</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/introduction.html">Introduction</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/introduction.html#chi-in-a-nutshell">Chi in a nutshell</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/introduction.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html">Data types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#booleans">Booleans</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#enumerations">Enumerations</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#numbers">Numbers</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#strings">Strings</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html#tuple-types">Tuple types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#notation">Notation</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#operator">Operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#lists">Lists</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#initialization">Initialization</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#sets">Sets</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#dictionaries">Dictionaries</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#custom-types">Custom types</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-assignment-statement">The assignment statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-if-statement">The <code>if</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-while-statement">The <code>while</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-for-statement">The <code>for</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/functions.html">Functions</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/functions.html#sorted-lists">Sorted lists</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/functions.html#sort">Sort</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/functions.html#insert">Insert</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/input-output.html">Input and output</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#the-read-function">The <code>read</code> function</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#reading-from-a-file">Reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#advanced-reading-from-a-file">Advanced reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#the-write-statement">The <code>write</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#writing-to-a-file">Writing to a file</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/stochastic-behavior.html">Modeling stochastic behavior</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/stochastic-behavior.html#distributions">Distributions</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#constant-distributions">Constant distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#discrete-distributions">Discrete distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#continuous-distributions">Continuous distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#references">References</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#simulating-stochastic-behavior">Simulating stochastic behavior</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/processes.html">Processes</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/processes.html#a-single-process">A single process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/processes.html#a-process-in-a-process">A process in a process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/processes.html#many-processes">Many processes</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/channels.html">Channels</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#a-channel">A channel</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#synchronization-channels">Synchronization channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#two-channels">Two channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#more-senders-or-receivers">More senders or receivers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/buffers.html">Buffers</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-one-place-buffer">A one-place buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-single-process-buffer">A single process buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#an-infinite-buffer">An infinite buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-token-buffer">A token buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-priority-buffer">A priority buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/servers.html">Servers with time</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/servers.html#the-clock">The clock</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/servers.html#adding-time">Adding time</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#a-deterministic-system">A deterministic system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#a-stochastic-system">A stochastic system</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/servers.html#two-servers">Two servers</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#serial-system">Serial system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#parallel-systems">Parallel systems</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/servers.html#assembly">Assembly</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/servers.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/conveyors.html">Conveyors</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#timers">Timers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#a-conveyor">A conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#a-priority-conveyor">A priority conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/experiments.html">Simulations and experiments</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/experiments.html#simulating-finite-systems">Simulating finite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/experiments.html#simulating-infinite-systems">Simulating infinite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/experiments.html#simulating-several-scenarios">Simulating several scenarios</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/svg-visualization.html">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-visualization.html#the-svg-file-format">The SVG file format</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-visualization.html#visualization">Visualization</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/svg-example.html">SVG visualization example</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#buffer-visualization">Buffer visualization</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#vertical-coordinates-trickery">Vertical coordinates trickery</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#server-process">Server process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#visualizing-the-server">Visualizing the server</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#copying-svg-elements">Copying SVG elements</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#moving-svg-elements">Moving SVG elements</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="index.html">Chi Reference Manual</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="globals.html">Global definitions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#enumeration-definitions">Enumeration definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#type-definitions">Type definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#constant-definitions">Constant definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#process-definitions">Process definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#model-definitions">Model definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#function-definitions">Function definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#experiment-definitions">Experiment definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#formal-parameters">Formal parameters</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#local-variables">Local variables</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#assignment-statement">Assignment statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#iterative-statements">Iterative statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#while-loop-statement">While loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#for-loop-statement">For loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#break-statement">Break statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#continue-statement">Continue statement</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#choice-statement">Choice statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#sub-process-statements">Sub-process statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#run-and-start-statements">Run and start statements</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#finish-statement">Finish statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#communication-statements">Communication statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#send-statement">Send statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#receive-statement">Receive statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#select-statement">Select statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#other-statements">Other statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#delay-statement">Delay statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#write-statement">Write statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#close-statement">Close statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#return-statement">Return statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#exit-statement">Exit statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#pass-statement">Pass statement</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="expressions.html">Expressions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#typed-expressions">Typed expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#enumeration-value">Enumeration value</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#boolean-expressions">Boolean expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#integer-expressions">Integer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#real-number-expressions">Real number expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#string-expressions">String expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#list-expressions">List expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#set-expressions">Set expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#dictionary-expressions">Dictionary expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#tuple-expression">Tuple expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#file-handle-expressions">File handle expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#read-expression">Read expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#timer-expressions">Timer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#channel-expressions">Channel expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#distribution-expressions">Distribution expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#process-expressions">Process expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#instance-expressions">Instance expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#matrix-expression">Matrix expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#cast-expressions">Cast expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#function-call-expressions">Function call expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#operator-priorities">Operator priorities</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="stdlib.html">Standard library functions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#integer-functions">Integer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#real-number-functions">Real number functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#string-functions">String functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#list-functions">List functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#set-functions">Set functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#dictionary-functions">Dictionary functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#timer-functions">Timer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#file-functions">File functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stdlib.html#process-instance-functions">Process instance functions</a></li>
        </ul></li>
       <li class="toc-cur-page toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Distributions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#constant-distributions">Constant distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#discrete-distributions">Discrete distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#continuous-distributions">Continuous distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#references">References</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="types.html">Types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="types.html#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#boolean-type">Boolean type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#integer-type">Integer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#real-type">Real type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#string-type">String type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#file-type">File type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#instance-type">Instance type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#timer-type">Timer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#matrix-type">Matrix type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#void-type">Void type</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="types.html#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#list-type">List type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#set-type">Set type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#dictionary-type">Dictionary type</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#tuple-type">Tuple type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#channel-type">Channel type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#distribution-type">Distribution type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#function-type">Function type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#process-type">Process type</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="lexicals.html">Lexical syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexicals.html#whitespace">Whitespace</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexicals.html#comment">Comment</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexicals.html#names">Names</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="migration.html">Model migration</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="svg-visualization.html">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-visualization.html#svg-interface">SVG interface</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-visualization.html#visualization-modification-commands">Visualization modification commands</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/index.html">Chi Tool Manual</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html">Software operation</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html#compile-and-simulate">Compile and simulate</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#quick-simulate">Quick simulate</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#compile-only">Compile only</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#simulate-a-compiled-model">Simulate a compiled model</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#terminating-a-simulation">Terminating a simulation</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/command-line.html">Command line options</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#simulator-options">Simulator options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#general-application-options">General application options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#compiler-options">Compiler options</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../release-notes.html">Chi release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-6-0-2024-12-20">Version 6.0 (2024-12-20)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-5-0-2024-10-03">Version 5.0 (2024-10-03)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../documentation.html">Chi documentation</a> &gt; <a class="breadcrumb" href="index.html">Chi Reference Manual</a> &gt; <span class="breadcrumb">Distributions</span>
   </div>
   <h2 id="distributions"><a class="anchor" href="#"></a>Distributions</h2>
   <div class="paragraph">
    <p>The Chi language has three kinds of distributions:</p>
   </div>
   <div class="ulist">
    <ul>
     <li>
      <p><a href="#constant-distributions">Constant distributions</a>, distributions returning always the same value</p></li>
     <li>
      <p><a href="#discrete-distributions">Discrete distributions</a>, distributions returning a boolean or integer value</p></li>
     <li>
      <p><a href="#continuous-distributions">Continuous distributions</a>, distributions returning a real number value</p></li>
    </ul>
   </div>
   <div class="paragraph">
    <p>The constant distributions are used during creation of the Chi program. Before adding stochastic behavior, you want to make sure the program itself is correct. It is much easier to verify correctness without stochastic behavior, but if you have to change the program again after the verification, you may introduce new errors in the process.</p>
   </div>
   <div class="paragraph">
    <p>The constant distributions solve this by allowing you to program with stochastic sampling in the code, but it is not doing anything (since you get the same predictable value on each sample operation). After verifying correctness of the program, you only need to modify the distributions that you use to get proper stochastic behavior.</p>
   </div>
   <div class="sect3">
    <h3 id="constant-distributions"><a class="anchor" href="#constant-distributions"></a>Constant distributions</h3>
    <div class="paragraph">
     <p>The constant distributions have very predictable samples, which makes them ideal for testing functioning of the program before adding stochastic behavior.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>dist</code> <code>bool</code> <strong>constant</strong><code>(bool b)</code></p>
       <div class="paragraph">
        <p>Distribution always returning <code>b</code>.</p>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>b</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>b</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p>-</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>int</code> <strong>constant</strong><code>(int i)</code></p>
       <div class="paragraph">
        <p>Distribution always returning <code>i</code>.</p>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>i</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>i</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p>-</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>real</code> <strong>constant</strong><code>(real r)</code></p>
       <div class="paragraph">
        <p>Distribution always returning <code>r</code>.</p>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>r</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>r</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p>-</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="discrete-distributions"><a class="anchor" href="#discrete-distributions"></a>Discrete distributions</h3>
    <div class="paragraph">
     <p>The discrete distributions return integer or boolean sample values.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>dist</code> <code>bool</code> <strong>bernoulli</strong><code>(real p)</code></p>
       <div class="paragraph">
        <p>Outcome of an experiment with chance <code>p</code> <code>(0 &lt;= p &lt;= 1)</code>.</p>
       </div>
       <div class="imageblock">
        <div class="content">
         <img src="distribution_plots/bernoulli.svg" alt="bernoulli">
        </div>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>{false, true}</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>p</code> (where <code>false</code> is interpreted as <code>0</code>, and <code>true</code> is interpreted as <code>1</code>)</p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>1 - p</code> (where <code>false</code> is interpreted as <code>0</code>, and <code>true</code> is interpreted as <code>1</code>)</p></td>
          </tr>
          <tr>
           <td class="hdlist1">See also</td>
           <td class="hdlist2">
            <p>Bernoulli(p), <a href="#ref-law07">[Law (2007)]</a>, page 302</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>int</code> <strong>binomial</strong><code>(int n, real p)</code></p>
       <div class="paragraph">
        <p>Number of successes when performing <code>n</code> experiments <code>(n &gt; 0)</code> with chance <code>p</code> <code>(0 &lt;= p &lt;= 1)</code>.</p>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>{0, 1, ..., n}</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>n * p</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>n * p * (1 - p)</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">See also</td>
           <td class="hdlist2">
            <p>bin(n, p), <a href="#ref-law07">[Law (2007)]</a>, page 304</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>int</code> <strong>geometric</strong><code>(real p)</code></p>
       <div class="paragraph">
        <p>Geometric distribution, number of failures before success for an experiment with chance <code>p</code> <code>(0 &lt; p &lt;= 1)</code>.</p>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>{0, 1, ...}</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>(1 - p) / p</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>(1 - p) / p^2</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">See also</td>
           <td class="hdlist2">
            <p>geom(p), <a href="#ref-law07">[Law (2007)]</a>, page 305</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>int</code> <strong>poisson</strong><code>(real lambda)</code></p>
       <div class="paragraph">
        <p>Poisson distribution.</p>
       </div>
       <div class="imageblock">
        <div class="content">
         <img src="distribution_plots/poisson.svg" alt="poisson">
        </div>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>{0, 1, ...}</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>lambda</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>lambda</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">See also</td>
           <td class="hdlist2">
            <p>Poison(lambda), <a href="#ref-law07">[Law (2007)]</a>, page 308</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>int</code> <strong>uniform</strong><code>(int a, b)</code></p>
       <div class="paragraph">
        <p>Integer uniform distribution from <code>a</code> to <code>b</code> excluding the upper bound.</p>
       </div>
       <div class="imageblock">
        <div class="content">
         <img src="distribution_plots/disc_uni.svg" alt="disc uni">
        </div>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>{a, a+1, ..., b-1}</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>(a + b - 1) / 2</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>((b - a)^2 - 1) / 12</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">See also</td>
           <td class="hdlist2">
            <p>DU(a, b - 1), <a href="#ref-law07">[Law (2007)]</a>, page 303</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="continuous-distributions"><a class="anchor" href="#continuous-distributions"></a>Continuous distributions</h3>
    <div class="ulist">
     <ul>
      <li>
       <p><code>dist</code> <code>real</code> <strong>beta</strong><code>(real p, q)</code></p>
       <div class="paragraph">
        <p>Beta distribution with shape parameters <code>p</code> and <code>q</code>, with <code>p &gt; 0</code> and <code>q &gt; 0</code>.</p>
       </div>
       <div class="imageblock">
        <div class="content">
         <img src="distribution_plots/beta.svg" alt="beta">
        </div>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>[0, 1]</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>p / (p + q)</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>p * q / ((p + q)^2 * (p + q + 1))</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">See also</td>
           <td class="hdlist2">
            <p>Beta(p, q), <a href="#ref-law07">[Law (2007)]</a>, page 291</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>real</code> <strong>erlang</strong><code>(double m, int k)</code></p>
       <div class="paragraph">
        <p>Erlang distribution with <code>k</code> a positive integer and <code>m &gt; 0</code>. Equivalent to <code>gamma(k, m / k)</code>.</p>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>m</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>m * m / k</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">See also</td>
           <td class="hdlist2">
            <p>ERL(m, k), <a href="#ref-banks98">[Banks (1998)]</a>, page 153</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>real</code> <strong>exponential</strong><code>(real m)</code></p>
       <div class="paragraph">
        <p>(Negative) exponential distribution with mean <code>m</code>, with <code>m &gt; 0</code>.</p>
       </div>
       <div class="imageblock">
        <div class="content">
         <img src="distribution_plots/exponential.svg" alt="exponential">
        </div>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>[0, infinite)</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>m</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>m * m</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">See also</td>
           <td class="hdlist2">
            <p>expo(m), <a href="#ref-law07">[Law (2007)]</a>, page 283</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>real</code> <strong>gamma</strong><code>(real a, b)</code></p>
       <div class="paragraph">
        <p>Gamma distribution, with shape parameter <code>a &gt; 0</code> and scale parameter <code>b &gt; 0</code>.</p>
       </div>
       <div class="imageblock">
        <div class="content">
         <img src="distribution_plots/gamma.svg" alt="gamma">
        </div>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>a * b</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>a * b^2</code></p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>real</code> <strong>lognormal</strong><code>(real m, v2)</code></p>
       <div class="paragraph">
        <p>Log-normal distribution.</p>
       </div>
       <div class="imageblock">
        <div class="content">
         <img src="distribution_plots/lognormal.svg" alt="lognormal">
        </div>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>[0, infinite)</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>exp(m + v2/2)</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>exp(2*m + v2) * (exp(v2) - 1)</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">See also</td>
           <td class="hdlist2">
            <p>N(m, v2), <a href="#ref-law07">[Law (2007)]</a>, page 290</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>real</code> <strong>normal</strong><code>(real m, v2)</code></p>
       <div class="paragraph">
        <p>Normal distribution.</p>
       </div>
       <div class="imageblock">
        <div class="content">
         <img src="distribution_plots/normal.svg" alt="normal">
        </div>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>(-infinite, infinite)</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>m</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>v2</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">See also</td>
           <td class="hdlist2">
            <p>N(m, v2), <a href="#ref-law07">[Law (2007)]</a>, page 288</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>real</code> <strong>random</strong><code>()</code></p>
       <div class="paragraph">
        <p>Random number generator.</p>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>[0, 1)</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>0.5</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>1 / 12</code></p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>real</code> <strong>triangle</strong><code>(real a, b, c)</code></p>
       <div class="paragraph">
        <p>Triangle distribution, with <code>a &lt; b &lt; c</code>.</p>
       </div>
       <div class="imageblock">
        <div class="content">
         <img src="distribution_plots/triangle.svg" alt="triangle">
        </div>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>[a, c]</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>(a + b + c) /3</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>(a^2 + c^2 + b^2 - a*b - a*c - b*c) / 18</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">See also</td>
           <td class="hdlist2">
            <p>Triangle(a, c, b), <a href="#ref-law07">[Law (2007)]</a>, page 300</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>real</code> <strong>uniform</strong><code>(real a, b)</code></p>
       <div class="paragraph">
        <p>Real uniform distribution from <code>a</code> to <code>b</code>, excluding upper bound.</p>
       </div>
       <div class="imageblock">
        <div class="content">
         <img src="distribution_plots/cont_uni.svg" alt="cont uni">
        </div>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>[a, b)</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>(a + b) / 2</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>(b - a)^2 / 12</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">See also</td>
           <td class="hdlist2">
            <p>U(a,b), <a href="#ref-law07">[Law (2007)]</a>, page 282, except that distribution has an inclusive upper bound.</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
      <li>
       <p><code>dist</code> <code>real</code> <strong>weibull</strong><code>(real a, b)</code></p>
       <div class="paragraph">
        <p>Weibull distribution with shape parameter <code>a</code> and scale parameter <code>b</code>, with <code>a &gt; 0</code> and <code>b &gt; 0</code>.</p>
       </div>
       <div class="imageblock">
        <div class="content">
         <img src="distribution_plots/weibull.svg" alt="weibull">
        </div>
       </div>
       <div class="hdlist">
        <table>
         <tbody>
          <tr>
           <td class="hdlist1">Range</td>
           <td class="hdlist2">
            <p><code>[0, infinite)</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Mean</td>
           <td class="hdlist2">
            <p><code>(b / a) * G(1 / a)</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">Variance</td>
           <td class="hdlist2">
            <p><code>(b^2 / a) * (2 * G(2 / a) - (1 / a) * G(1 / a)^2)</code> with <code>G(x)</code> the Gamma function, <code>G(x)</code> <code>=</code> integral over <code>t</code> from <code>0</code> to <code>infinity</code>, for <code>t^(x - 1) * exp(-t)</code></p></td>
          </tr>
          <tr>
           <td class="hdlist1">See also</td>
           <td class="hdlist2">
            <p>Weibull(a, b), <a href="#ref-law07">[Law (2007)]</a>, page 284</p></td>
          </tr>
         </tbody>
        </table>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="references"><a class="anchor" href="#references"></a>References</h3>
    <div class="ulist bibliography">
     <ul class="bibliography">
      <li>
       <p><a id="ref-banks98"></a>[Banks (1998)] Jerry Banks, "Handbook of Simulation: Principles, Methodology, Advances, Applications, and Practice", John Wiley &amp; Sons, Inc., 1998, doi:<a href="https://doi.org/10.1002/9780470172445">10.1002/9780470172445</a></p></li>
      <li>
       <p><a id="ref-law07"></a>[Law (2007)] Averill M. Law, "Simulation Modeling and Analysis", fourth edition, McGraw-Hill, 2007</p></li>
     </ul>
    </div>
   </div>
  </div>
  <script src="../assets/highlight.min.js"></script>
  <script src="../assets/languages/asciidoc.min.js"></script>
  <script src="../assets/languages/bash.min.js"></script>
  <script src="../assets/languages/bnf.min.js"></script>
  <script src="../assets/languages/c.min.js"></script>
  <script src="../assets/languages/chi.min.js"></script>
  <script src="../assets/languages/cif.min.js"></script>
  <script src="../assets/languages/console.min.js"></script>
  <script src="../assets/languages/css.min.js"></script>
  <script src="../assets/languages/dsm.min.js"></script>
  <script src="../assets/languages/java.min.js"></script>
  <script src="../assets/languages/javascript.min.js"></script>
  <script src="../assets/languages/markdown.min.js"></script>
  <script src="../assets/languages/mcrl2.min.js"></script>
  <script src="../assets/languages/none.min.js"></script>
  <script src="../assets/languages/plcst.min.js"></script>
  <script src="../assets/languages/properties.min.js"></script>
  <script src="../assets/languages/raildiagram.min.js"></script>
  <script src="../assets/languages/setext.min.js"></script>
  <script src="../assets/languages/shell.min.js"></script>
  <script src="../assets/languages/tooldef.min.js"></script>
  <script src="../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>Chi documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v6.0</span>
    <br><a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>